import numpy as np
import cv2
import time
import socket

ip_addr = [
    '2001:67c:20a1:1095:ba27:ebff:feb9:db12',
    '2001:67c:20a1:1095:ba27:ebff:fe23:60d7',
    '2001:67c:20a1:1095:ba27:ebff:fe71:dd32',
]

cap = cv2.VideoCapture(0)
sock = socket.socket(socket.AF_INET6, socket.SOCK_DGRAM)
while(True):
    # Capture frame-by-frame
    ret, frame = cap.read()

    # Our operations on the frame come here
    im_gray = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)

    # Display the resulting frame
    #cv2.imshow('frame', im_gray)
    if cv2.waitKey(1) & 0xFF == ord('q'):
        break
    
    # convert to 144x120 monochrome
    im_small = cv2.resize(im_gray, (144, 120))    
    thresh, im_bw = cv2.threshold(im_small, 128, 255, cv2.THRESH_BINARY | cv2.THRESH_OTSU)
    cv2.imshow('frame', im_bw)
    im_rot = np.rot90(im_bw, 3)
    im_split = np.split(im_rot, 3, axis=0)
    for i in range(0, 3):
        im_flat = np.packbits(np.ravel(im_split[i]))
        im_bytes = im_flat.tobytes();
        sock.sendto(im_bytes, (ip_addr[i], 2323))
    
    time.sleep(1)


# When everything done, release the capture
cap.release()
cv2.destroyAllWindows()
